#ifndef CAPISERVER_H
#define CAPISERVER_H

// Qt includes
#include <QStringList>
#include <QTcpServer>

// JetServer includes
#include "CJetFTPServer.h"

class CAPIServer : public QTcpServer
{
    Q_OBJECT

public:

    CAPIServer();
    ~CAPIServer();

public slots:

    void OnConnection();

private:

    // Utility functions
    QString JSONError(QString);
    QString XMLError(QString);
    QString Error(QString,bool);
    QString Success(bool);

    // Processing functions
    QString ProcessRequest(QString);
    QString ProcessJetServerRequest(QStringList, bool);
    QString ProcessJetFTPRequest(QStringList, bool);

    // Connections to the clients
    CJetFTPServer m_jetftp;
};

#endif // CAPISERVER_H
