#include "CApplicationServer.h"

CApplicationServer::CApplicationServer(QString name, int port)
    : m_name(name), m_connection_number(0)
{
    // listen on the following port
    listen(QHostAddress::Any, port);

    // Output status information
    qDebug(tr("Listening for %1 connections on port %2...")
           .arg(m_name).arg(port).toUtf8().data());
}

CApplicationServer::~CApplicationServer()
{
    qDebug(tr("%1 module shut down.").arg(m_name).toUtf8().data());
}

void CApplicationServer::incomingConnection(int handle)
{
    CApplicationSocket * pSocket = CreateSocket(handle);

    // Now we add this item to our map.
    m_map[m_connection_number++] = pSocket;

    connect(pSocket,SIGNAL(Finished(CApplicationSocket *)),SLOT(OnComplete(CApplicationSocket *)));
}

CApplicationSocket * CApplicationServer::GetSocket(int i)
{
    if(m_map.contains(i))
        return m_map[i];
    return NULL;
}

void CApplicationServer::OnComplete(CApplicationSocket * pSocket)
{
    // Remove it from our map.
    m_map.remove(m_map.key(pSocket));

    delete pSocket;
}
