#ifndef CAPPLICATIONSERVER_H
#define CAPPLICATIONSERVER_H

// Qt includes
#include <QMap>
#include <QTcpServer>

// JetServer includes
#include <CApplicationSocket.h>

class CApplicationServer : public QTcpServer
{
    Q_OBJECT

public:

    CApplicationServer(QString,int);
    virtual ~CApplicationServer();

    void incomingConnection(int);

    CApplicationSocket * GetSocket(int);
    QList<int>           GetSocketNumbers() { return m_map.keys(); }

protected:

    virtual CApplicationSocket * CreateSocket(int) = 0;

    // The application name
    QString m_name;

    // The map of instances to numbers
    // (used to identify the connections)
    QMap<int,CApplicationSocket *> m_map;

public slots:

    void OnComplete(CApplicationSocket *);

private:

    int m_connection_number;

};

#endif // CAPPLICATIONSERVER_H
