#ifndef CAPPLICATIONSOCKET_H
#define CAPPLICATIONSOCKET_H

// Qt includes
#include <QTcpSocket>
#include <QThread>

class CApplicationSocket : public QTcpSocket
{
    Q_OBJECT

public:

    // Constructor / destructor
    CApplicationSocket(QString,int);
    ~CApplicationSocket();

    void SendMessage(QString);

public slots:

    void OnInitialize();
    void OnData();
    void OnMessage(QString);
    void OnDisconnect();

signals:

    void WriteMessage(QString);
    void Finished(CApplicationSocket *);

protected:

    virtual void ProcessMessage(QString,QString)=0;

private:

    void CommandONLINE(QString);
    void CommandOFFLINE();

    QThread m_thread;
    int m_socket;
    QString m_name;
};

#endif // CAPPLICATIONSOCKET_H
