#include "CJetServerCommunicator.h"

// Qt includes
#include <QHostAddress>

CJetServerCommunicator::CJetServerCommunicator(quint16 port)
{
    m_socket.connectToHost(QHostAddress::LocalHost, port, QIODevice::ReadWrite);
    m_socket.waitForConnected();

    connect(&m_socket,SIGNAL(readyRead()),SLOT(OnMessage()));
}

CJetServerCommunicator::~CJetServerCommunicator()
{
    m_socket.close();
}

void CJetServerCommunicator::SendMessage(QString message)
{
    // Immediately abort if the connection is not
    // valid.
    if(!IsConnected())
        return;

    message.append("\r\n");

    QByteArray raw_message = message.toUtf8();

    // Now the message
    m_socket.write(raw_message);
    m_socket.waitForBytesWritten();
}

void CJetServerCommunicator::OnMessage()
{
    QByteArray data = m_socket.readLine();

    emit NewMessage(QString(data).trimmed());
}
