#ifndef CJETSERVERCOMMUNICATOR_H
#define CJETSERVERCOMMUNICATOR_H

#include <jetservercommunicator/CJetServerCommunicator_global.h>

// Qt includes
#include <QObject>
#include <QTcpSocket>

class JETSERVERCOMMUNICATORSHARED_EXPORT CJetServerCommunicator : public QObject
{
    Q_OBJECT

public:

    // Constructor / destructor
    CJetServerCommunicator(quint16);
    ~CJetServerCommunicator();

    // Used to determine whether the
    // application could connect to
    // JetServer or not.
    bool IsConnected() { return m_socket.state() == QAbstractSocket::ConnectedState; }

    // Used for sending a message
    void SendMessage(QString);

public slots:

    void OnMessage();

signals:

    // Indicates that a new message is available
    void NewMessage(QString);

private:

    QTcpSocket m_socket;
};

#endif // CJETSERVERCOMMUNICATOR_H
